
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.create(
            {
                id: data.id || undefined,
        
        rating: data.rating
        ||
        null
            ,
            
        communication_rating: data.communication_rating
        ||
        null
            ,
            
        knowledge_rating: data.knowledge_rating
        ||
        null
            ,
            
        punctuality_rating: data.punctuality_rating
        ||
        null
            ,
            
        value_rating: data.value_rating
        ||
        null
            ,
            
        review_text: data.review_text
        ||
        null
            ,
            
        would_recommend: data.would_recommend
        ||
        false
        
            ,
            
        tutor_response: data.tutor_response
        ||
        null
            ,
            
        tutor_response_at: data.tutor_response_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reviews.setBooking( data.booking || null, {
            transaction,
        });
        
        await reviews.setTutor( data.tutor || null, {
            transaction,
        });
        
        await reviews.setLearner( data.learner || null, {
            transaction,
        });
        

        

        

        return reviews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reviewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rating: item.rating
            ||
            null
            ,
            
                communication_rating: item.communication_rating
            ||
            null
            ,
            
                knowledge_rating: item.knowledge_rating
            ||
            null
            ,
            
                punctuality_rating: item.punctuality_rating
            ||
            null
            ,
            
                value_rating: item.value_rating
            ||
            null
            ,
            
                review_text: item.review_text
            ||
            null
            ,
            
                would_recommend: item.would_recommend
            ||
            false
        
            ,
            
                tutor_response: item.tutor_response
            ||
            null
            ,
            
                tutor_response_at: item.tutor_response_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reviews = await db.reviews.bulkCreate(reviewsData, { transaction });

        // For each item created, replace relation files
        

        return reviews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const reviews = await db.reviews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.communication_rating !== undefined) updatePayload.communication_rating = data.communication_rating;
        
        
        if (data.knowledge_rating !== undefined) updatePayload.knowledge_rating = data.knowledge_rating;
        
        
        if (data.punctuality_rating !== undefined) updatePayload.punctuality_rating = data.punctuality_rating;
        
        
        if (data.value_rating !== undefined) updatePayload.value_rating = data.value_rating;
        
        
        if (data.review_text !== undefined) updatePayload.review_text = data.review_text;
        
        
        if (data.would_recommend !== undefined) updatePayload.would_recommend = data.would_recommend;
        
        
        if (data.tutor_response !== undefined) updatePayload.tutor_response = data.tutor_response;
        
        
        if (data.tutor_response_at !== undefined) updatePayload.tutor_response_at = data.tutor_response_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await reviews.update(updatePayload, {transaction});

        
        
        if (data.booking !== undefined) {
            await reviews.setBooking(
              
              data.booking,
              
              { transaction }
            );
        }
        
        if (data.tutor !== undefined) {
            await reviews.setTutor(
              
              data.tutor,
              
              { transaction }
            );
        }
        
        if (data.learner !== undefined) {
            await reviews.setLearner(
              
              data.learner,
              
              { transaction }
            );
        }
        

        
        

        

        return reviews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reviews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reviews) {
                await record.destroy({transaction});
            }
        });


        return reviews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findByPk(id, options);

        await reviews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reviews.destroy({
            transaction
        });

        return reviews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findOne(
            { where },
            { transaction },
        );

        if (!reviews) {
            return reviews;
        }

        const output = reviews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.booking = await reviews.getBooking({
            transaction
        });
        
        
        output.tutor = await reviews.getTutor({
            transaction
        });
        
        
        output.learner = await reviews.getLearner({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.bookings,
        as: 'booking',
        
        where: filter.booking ? {
          [Op.or]: [
            { id: { [Op.in]: filter.booking.split('|').map(term => Utils.uuid(term)) } },
            {
              level_name: {
                [Op.or]: filter.booking.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'tutor',
        
        where: filter.tutor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tutor.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.tutor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'learner',
        
        where: filter.learner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.learner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.learner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.review_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reviews',
                        'review_text',
                        filter.review_text,
                    ),
                };
            }
            
            if (filter.tutor_response) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reviews',
                        'tutor_response',
                        filter.tutor_response,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.communication_ratingRange) {
                const [start, end] = filter.communication_ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    communication_rating: {
                    ...where.communication_rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    communication_rating: {
                    ...where.communication_rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.knowledge_ratingRange) {
                const [start, end] = filter.knowledge_ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    knowledge_rating: {
                    ...where.knowledge_rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    knowledge_rating: {
                    ...where.knowledge_rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.punctuality_ratingRange) {
                const [start, end] = filter.punctuality_ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    punctuality_rating: {
                    ...where.punctuality_rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    punctuality_rating: {
                    ...where.punctuality_rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.value_ratingRange) {
                const [start, end] = filter.value_ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value_rating: {
                    ...where.value_rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value_rating: {
                    ...where.value_rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tutor_response_atRange) {
                const [start, end] = filter.tutor_response_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tutor_response_at: {
                    ...where.tutor_response_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tutor_response_at: {
                    ...where.tutor_response_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.would_recommend) {
                where = {
                    ...where,
                would_recommend: filter.would_recommend,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reviews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reviews',
                        'review_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reviews.findAll({
            attributes: [ 'id', 'review_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['review_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.review_text,
        }));
    }

    
};

